var sentences;

/* Use below function to detect different topics from messages */
function topicise() {
	var documents = new Array();
	var f = {};
	var vocab=new Array();
	var docCount=0;
	for(var i=0;i<sentences.length;i++) {
	console.log('In topicise '+ sentences);
		if (sentences[i]=="") continue;
		var words = sentences[i].split(/[\s,\"]+/);
		console.log('words '+ words);
		if(!words) continue;
		var wordIndices = new Array();
		for(var wc=0;wc<words.length;wc++) {
			var w=words[wc].toLowerCase().replace(/[^a-z\'A-Z0-9 ]+/g, '');
			//TODO: Add stemming
			if (w=="" || w.length==1 || stopwords[w] || w.indexOf("http")==0) continue;
			if (f[w]) { 
				f[w]=f[w]+1;			
			} 
			else if(w) { 
				f[w]=1; 
				vocab.push(w); 
			}	
			wordIndices.push(vocab.indexOf(w));
		}
		if (wordIndices && wordIndices.length>0) {
			documents[docCount++] = wordIndices;
		}
	}
		
	var V = vocab.length;
	var M = documents.length;
	var K = 2;
	var alpha = 0.1;  // per-document distributions over topics
	var beta = .01;  // per-topic distributions over words

	lda.configure(documents,V,10000, 2000, 100, 10);
	lda.gibbs(K, alpha, beta);

	var theta = lda.getTheta();
	var phi = lda.getPhi();

	var text = '';

	//topics
	var topTerms=20;
	
	var topicText = new Array();
	
	$('#topiccloud').append("<ul id='listData'></ul>");
	
	$('ul').empty();
	
	for (var k = 0; k < 1; k++) {
		
		var tuples = new Array();
		for (var w = 0; w < phi[k].length; w++) {
			 tuples.push(""+phi[k][w].toPrecision(2)+"_"+vocab[w]);
		}
		tuples.sort().reverse();
		if(topTerms>vocab.length) topTerms=vocab.length;
		
		topicText[k]='';
		
		for (var t = 0; t < topTerms; t++) {
			var topicTerm=tuples[t].split("_")[1];
			console.log('Topic Terms ' + topicTerm);
			var prob=parseInt(tuples[t].split("_")[0]*100);
			if (prob<0.0001) continue;
			var space = " ---->    ";	
			
			 $('#listData').append('<li>'+topicTerm + space + prob + ' % ' +'</li>');
			console.log("topic "+k+": "+ topicTerm+" = " + prob  + "%");
			topicText[k] += ( topicTerm +" ");
			
		}
		$('<div></br></div>').appendTo("#listData");
	}
	
}

/* Use below function to show the messages as a list */
function makeUL(array) {
    // Create the list element:
    var list = document.createElement('ul');
    list.setAttribute("id", "parent");
    for(var i = 0; i < array.length - 1; i++) {
    var id = i;
        // Create the list item:
        var item = document.createElement('li');
     
        // Set its contents:
        item.appendChild(document.createTextNode(array[i]));

        // Add it to the list:
        list.appendChild(item);
        item.setAttribute("id",id);
        
        list.addEventListener("click",function(e){
	 var contentText = document.querySelector('#text');
	 contentText.innerHTML = array[e.target.id];
      });
    }

    // Finally, return the constructed list:
    return list;
}

/* Use below function to get all messages */
function getMessageList()
{
var appControlReplyCallback = {
				// callee sent a reply
				onsuccess: function(data) {
				console.log('data length ' + data.length);
					for (var i = 0; i < data.length; i++) {
						if (data[i].key == "http://tizen.org/appcontrol/data/selected") {
							var msgs = data[i].value[0];
							var res = msgs.split('XC');
							for(var j = 0; j<res.length; j++)
							console.log('res val' + res[j] + '\n');
							document.getElementById('msgList').innerHTML = "";
							document.getElementById('msgList').appendChild(makeUL(res));
						}
					}
				},
				// callee returned failure
				onfailure: function() {
					console.log('The launch application control failed');
				}
		}		
		var obj1 = new tizen.ApplicationControl("http://tizen.org/appcontrol/operation/service",
				null,
				null,
				null
		);
		tizen.application.launchAppControl(obj1,
				"WxvVevPjzt.servicesms",
				function() {console.log("Launch Service succeeded"); },
				function(e) {console.log("Launch Service failed : " + e.message);},
				appControlReplyCallback);
}

/* Below function will be called on Analyze button click from UI */
function btnTopiciseClicked() {
	$('#btnTopicise').attr('disabled','disabled');
	sentences = $('#text').val().split("\n");
	topicise();
	$('#btnTopicise').removeAttr('disabled');
	
}
